/**
 *
 */
package de.intevation.gnv.propertiesreader;

import java.util.Map;

import org.apache.log4j.Logger;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class MapPropertiesReader implements PropertiesReader {
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(MapPropertiesReader.class);

    private Map<String,String> properties = null;
    /**
     * Constructor
     */
    public MapPropertiesReader(Map<String, String> properties) {
        super();
        this.properties = properties;
    }

    /**
     * @see de.intevation.gnv.propertiesreader.PropertiesReader#getPropertieValue(java.lang.String, java.lang.String)
     */
    public String getPropertieValue(String key, String defaultValue) {
        String value = this.properties.get(key);
        if (value == null){
            value = defaultValue;
        }
        return value;
    }

}
