/**
 *
 */
package de.intevation.gnv.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;
import org.w3c.dom.Document;

import de.intevation.gnv.artifactdatabase.client.DefaultArtifactDatabaseClient;

import junit.framework.TestCase;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class XSLTransformerTestCase extends TestCase {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = null;
    
    static{
        BasicConfigurator.configure();
        log = Logger.getLogger(DefaultArtifactDatabaseClient.class);
    }
    
    public XSLTransformerTestCase() {
        super();
    }

    public XSLTransformerTestCase(String name) {
        super(name);
    }

    
    public void testDescribeUI(){
        
        try {
            //System.setProperty("javax.xml.transform.TransformerFactory","com.icl.saxon.TransformerFactoryImpl");
            Document document = new XMLUtils().readDocument(new FileInputStream(new File("src/test/ressources/describe-ui-test.xml")));
            XSLTransformer transformer = new XSLTransformer();
            String value = transformer.transform(document, "UTF-8", "src/main/webapp/WEB-INF/config/templates/describe-ui.xsl");
            log.debug(value);
        } catch (FileNotFoundException e) {
            log.error(e,e);
        }
    }
}
